"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createGetModulesExpress = void 0;
const express_1 = require("express");
const modules_1 = require("./modules");
function createGetModulesExpress(modules) {
    const router = (0, express_1.Router)();
    const modulesMethodSettings = (0, modules_1.createGetModulesMethod)(modules);
    router[modulesMethodSettings.method.toLowerCase()](modulesMethodSettings.path, (req, res) => __awaiter(this, void 0, void 0, function* () {
        try {
            const response = yield modulesMethodSettings.handler(req.body, req);
            res.send(response);
        }
        catch (e) {
            res.status(500).send({
                error: e.message,
                status: 500,
            });
        }
    }));
    return router;
}
exports.createGetModulesExpress = createGetModulesExpress;
