"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createGetModulesHapi16Plugin = void 0;
const modules_1 = require("./modules");
function createGetModulesHapi16Plugin(modules, routeParams) {
    const modulesMethodSettings = (0, modules_1.createGetModulesMethod)(modules);
    const register = (server, options, next) => {
        server.route({
            method: modulesMethodSettings.method,
            path: modulesMethodSettings.path,
            config: routeParams,
            handler: (request, reply) => __awaiter(this, void 0, void 0, function* () {
                try {
                    const response = yield modulesMethodSettings.handler(request.payload, request);
                    reply(response);
                }
                catch (e) {
                    reply({
                        error: e.message,
                        status: 500,
                    }).code(500);
                }
            }),
        });
        next();
    };
    register.attributes = {
        name: `@alfalab/scripts-server${modulesMethodSettings.path}`,
    };
    return register;
}
exports.createGetModulesHapi16Plugin = createGetModulesHapi16Plugin;
