"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createGetModulesHapi20Plugin = void 0;
const modules_1 = require("./modules");
function createGetModulesHapi20Plugin(modules, routeParams) {
    const modulesMethodSettings = (0, modules_1.createGetModulesMethod)(modules);
    const plugin = {
        name: `@alfalab/scripts-server${modulesMethodSettings.path}`,
        version: '1.0.0',
        register: (server, options) => {
            server.route({
                method: modulesMethodSettings.method,
                path: modulesMethodSettings.path,
                options: Object.assign({}, routeParams),
                handler: (request, h) => __awaiter(this, void 0, void 0, function* () {
                    try {
                        return yield modulesMethodSettings.handler(request.payload, request);
                    }
                    catch (e) {
                        h
                            .response({
                            error: e.message,
                            status: 500,
                        })
                            .code(500);
                    }
                }),
            });
        }
    };
    return plugin;
}
exports.createGetModulesHapi20Plugin = createGetModulesHapi20Plugin;
